<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Tomcat | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="Tomcat 是什么?Tomcat 由JAVA语言开发的Java容器，实现了对 Servlet 和 JSP 的支持，并提供了作为Web服务器的一些特有功能，Tomcat是一种类似于IIS、Apache Http的Web服务端程序， Tomcat 本身也内含了一个 HTTP 服务器，它也可以被视作一个单独的 Web 服务器。也就是Web容器。 Servlet：是应用在服务端的小程序，由JAVA语言编">
<meta property="og:type" content="article">
<meta property="og:title" content="Tomcat">
<meta property="og:url" content="http://example.com/2021/01/21/Tomcat/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="Tomcat 是什么?Tomcat 由JAVA语言开发的Java容器，实现了对 Servlet 和 JSP 的支持，并提供了作为Web服务器的一些特有功能，Tomcat是一种类似于IIS、Apache Http的Web服务端程序， Tomcat 本身也内含了一个 HTTP 服务器，它也可以被视作一个单独的 Web 服务器。也就是Web容器。 Servlet：是应用在服务端的小程序，由JAVA语言编">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-01-21T02:31:00.000Z">
<meta property="article:modified_time" content="2021-02-06T10:24:20.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/01/21/Tomcat/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-02-06 18:24:20'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Tomcat</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-01-21T02:31:00.000Z" title="发表于 2021-01-21 10:31:00">2021-01-21</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-02-06T10:24:20.000Z" title="更新于 2021-02-06 18:24:20">2021-02-06</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Tomcat/">Tomcat</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h5 id="Tomcat-是什么"><a href="#Tomcat-是什么" class="headerlink" title="Tomcat 是什么?"></a>Tomcat 是什么?</h5><p>Tomcat 由JAVA语言开发的Java容器，实现了对 Servlet 和 JSP 的支持，并提供了作为Web服务器的一些特有功能，Tomcat是一种类似于IIS、Apache Http的Web服务端程序， Tomcat 本身也内含了一个 HTTP 服务器，它也可以被视作一个单独的 Web 服务器。也就是Web容器。</p>
<p>Servlet：是应用在服务端的小程序，由JAVA语言编写，本身支持各种JAVA相关的请求，但是大多用于接收web服务发来的请求，与数据库交互并将响应交给web服务</p>
<p>JDK：JAVA开发工具包。</p>
<p>常用工具：</p>
<blockquote>
<p>Java：运行编译后的类文件</p>
</blockquote>
<blockquote>
<p>Jar：对类文件进行打包</p>
</blockquote>
<blockquote>
<p>Javac：对源文件中的注释提取文档</p>
</blockquote>
<blockquote>
<p>Jconsole：远程连接工具</p>
</blockquote>
<blockquote>
<p>Jre：JAVA运行环境</p>
</blockquote>
<h5 id="部署tomcat"><a href="#部署tomcat" class="headerlink" title="部署tomcat"></a>部署tomcat</h5><p>配置Java环境</p>
<p>解压软件包</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># tar zxf jdk-8u201-linux-x64.tar.gz</span><br></pre></td></tr></table></figure>
<p>将jdk解压后的目录移动到/usr/local/起名为java</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># mv &#x2F;root&#x2F;jdk1.8.0_201&#x2F; &#x2F;usr&#x2F;local&#x2F;java</span><br></pre></td></tr></table></figure>
<p>删除原先的旧java</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># rm -rf &#x2F;usr&#x2F;bin&#x2F;java</span><br></pre></td></tr></table></figure>
<p>配置Java环境变量</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line"># echo &#39;export JAVA_HOME&#x3D;&#x2F;usr&#x2F;local&#x2F;java</span><br><span class="line"># 设置jre（Jave Runtime Environment：java运行时环境）的安装目录变量</span><br><span class="line">&gt; export JRE_HOME&#x3D;&#x2F;usr&#x2F;local&#x2F;java&#x2F;jre&#x2F;</span><br><span class="line"># 设置类文件路径，冒号代表加的意思，引用以上设置的变量</span><br><span class="line">&gt; export CLASSPATH&#x3D;$JAVA_HOME&#x2F;lib:$JRE_HOME&#x2F;lib</span><br><span class="line"># 最后一行，相当于windows系统的命令环境变量，就是新添了两个java以及jre的命令变量</span><br><span class="line"># $PATH代表原有的环境变量，使用变量复用</span><br><span class="line">&gt; export PATH&#x3D;$PATH:$JAVA_HOME&#x2F;bin:$JRE_HOME&#x2F;bin&#39; &gt;&gt; &#x2F;etc&#x2F;profile</span><br></pre></td></tr></table></figure>
<p>加载编写的profile文件</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># source &#x2F;etc&#x2F;profile</span><br></pre></td></tr></table></figure>
<p>查看版本号</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># java -version</span><br><span class="line">java version &quot;1.8.0_201&quot;</span><br><span class="line">Java(TM) SE Runtime Environment (build 1.8.0_201-b09)</span><br><span class="line">Java HotSpot(TM) 64-Bit Server VM (build 25.201-b09, mixed mode)</span><br></pre></td></tr></table></figure>
<p>安装Tomcat</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">tar zxf apache-tomcat-8.5.35.tar.gz </span><br><span class="line">mv apache-tomcat-8.5.35 &#x2F;usr&#x2F;local&#x2F;tomcat</span><br></pre></td></tr></table></figure>
<p>启动服务：<code>/usr/local/tomcat/bin/startup.sh</code></p>
<p>停止服务：<code>/usr/local/tomcat/bin/shutdown.sh</code></p>
<blockquote>
<p>8080：接收客户端请求</p>
</blockquote>
<blockquote>
<p>8005：用于接收shutdown指令</p>
</blockquote>
<blockquote>
<p>8009：用于tomcat接受其他web服务发来的请求</p>
</blockquote>
<p>server.xml主配置文件</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br></pre></td><td class="code"><pre><span class="line">vi &#x2F;usr&#x2F;local&#x2F;tomcat&#x2F;conf&#x2F;server.xml</span><br><span class="line">&lt;Server port&#x3D;&quot;8005&quot; shutdown&#x3D;&quot;SHUTDOWN&quot;&gt;&lt;&#x2F;Server&gt;</span><br><span class="line">port：server模块监听的端口号，可以自定义，只有端口号不冲突，为-1时表示不接受关闭指令</span><br><span class="line">shutdown：server模块接收到的参数指定的指令时就关闭tomcat程序</span><br><span class="line"></span><br><span class="line">&lt;Service name&#x3D;&quot;Catalina&quot;&gt;&lt;&#x2F;Service&gt;</span><br><span class="line">name：指定该servie的名字，可以有多个service通过名字来区分</span><br><span class="line"></span><br><span class="line">&lt;Connector port&#x3D;&quot;8080&quot; protocol&#x3D;&quot;HTTP&#x2F;1.1&quot;</span><br><span class="line">           connectionTimeout&#x3D;&quot;20000&quot;</span><br><span class="line">           redirectPort&#x3D;&quot;8443&quot; &#x2F;&gt;&lt;&#x2F;Connector&gt;</span><br><span class="line">&lt;Connector port&#x3D;&quot;8009&quot; protocol&#x3D;&quot;AJP&#x2F;1.3&quot; redirectPort&#x3D;&quot;8443&quot; &#x2F;&gt;</span><br><span class="line">port：tomcat对客户端开放的端口号，8080是用于接收客户端发送的http请求，8009是用于tomcat接受其他web服务发来的请求</span><br><span class="line">protocol：客户端连接tomcat使用的协议，AJP协议用于tomcat与其他web服务建立连接使用的</span><br><span class="line">connectionTimeout：与tomcat的连接超时时间，单位毫秒</span><br><span class="line">redirectPort：当tomcat配置为https时，如果客户端仍然使用http协议访问，强制对客户端使用的协议转换为https，并将端口转换为8443</span><br><span class="line"></span><br><span class="line">&lt;Engine name&#x3D;&quot;Catalina&quot; defaultHost&#x3D;&quot;localhost&quot;&gt;&lt;&#x2F;Engine&gt;</span><br><span class="line">name：该engine的名字，如果有多个service用来区分不同的引擎，并在日志中通过 名字进行标识</span><br><span class="line">default Host：引擎接受请求通过客户端请求的URL的IP&#x2F;域名&#x2F;主机名部分匹配Host模块，如果没有匹配到的则把请求交给defaultHost指定的主机处理，所以必须要有一个Host模块的主机名为defaultHost指定的名字</span><br><span class="line"></span><br><span class="line">&lt;Host name&#x3D;&quot;localhost&quot;  appBase&#x3D;&quot;webapps&quot;</span><br><span class="line">          unpackWARs&#x3D;&quot;true&quot; autoDeploy&#x3D;&quot;true&quot;&gt;</span><br><span class="line">&lt;Context path&#x3D;”&#x2F;test” docBase&#x3D;”&#x2F;haha”&gt;&lt;&#x2F;Context&gt;</span><br><span class="line">&lt;&#x2F;Host&gt;</span><br><span class="line">name：该host也就是虚拟主机对应的名字，用来engine对客户端访问的url中的主机部分进行匹配</span><br><span class="line">appBase：该虚拟主机对应的站点目录，webapps是一个相对路径，其绝对路径为“&#x2F;usr&#x2F;local&#x2F;tomcat&#x2F;webapps”</span><br><span class="line">path：客户端访问的URL指定的名字如果是&#x2F;test那么客户端要找的数据对应的位置就在&#x2F;haha目录下</span><br><span class="line">docBase：web应用存放位置</span><br><span class="line">&lt;Valve className&#x3D;&quot;org.apache.catalina.valves.AccessLogValve&quot; directory&#x3D;&quot;logs&quot;</span><br><span class="line">               prefix&#x3D;&quot;localhost_access_log&quot; suffix&#x3D;&quot;.txt&quot;</span><br><span class="line">               pattern&#x3D;&quot;%h %l %u %t &quot;%r&quot; %s %b&quot; &#x2F;&gt;</span><br><span class="line">Directory：指定访问日志存放的位置，logs是相对路径，绝对路径为“&#x2F;usr&#x2F;local&#x2F;tomcat&#x2F;logs”</span><br><span class="line">Prefix：指定访问日志文件的前缀</span><br><span class="line">Suffix：指定访问日志文件的后缀</span><br><span class="line">Pattern：指定日志文件的格式</span><br><span class="line">- %h：记录发送该请求的主机的IP地址，可能是客户端的IP，可能是代理服务器的IP（谁最终将请求交给tomcat，这里就是谁的IP）</span><br><span class="line">- %l：记录该请求使用的逻辑用户，如果没有就用-表示</span><br><span class="line">- %u：记录该请求的真实用户，如果没有则用-表示</span><br><span class="line">- %t：记录该请求的发送时间</span><br><span class="line">- %quot；：表示“”引号</span><br><span class="line">- %r：记录请求的请求行</span><br><span class="line">- %s：记录对该请求响应的状态码	</span><br><span class="line">- %b：记录该请求相应的字节数</span><br><span class="line">- %D：记录该请求响应的时间，可以用来测试tomcat的性能</span><br></pre></td></tr></table></figure>
<h5 id="Tomcat多实例"><a href="#Tomcat多实例" class="headerlink" title="Tomcat多实例"></a>Tomcat多实例</h5><blockquote>
<p>通过修改不同tomcat结点的配置文件中的端口来启动不同的tomcat实例</p>
</blockquote>
<p>示例一：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">tar zxf apache-tomcat-8.5.33.tar.gz</span><br><span class="line">cp &#x2F;root&#x2F;apache-tomcat-8.5.33 &#x2F;usr&#x2F;local&#x2F;tomcat</span><br><span class="line">sh &#x2F;usr&#x2F;local&#x2F;tomcat&#x2F;bin&#x2F;startup.sh		&#x2F;&#x2F;启动第一个实例</span><br><span class="line">netstat -anpt | grep java		&#x2F;&#x2F;查看到监听了三个端口8080、8005、8009</span><br></pre></td></tr></table></figure>
<p>示例二：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line">cp &#x2F;root&#x2F;apache-tomcat-8.5.33 &#x2F;usr&#x2F;local&#x2F;tomcat2</span><br><span class="line">vim &#x2F;usr&#x2F;local&#x2F;tomcat2&#x2F;conf&#x2F;server.xml</span><br><span class="line">修改：</span><br><span class="line">&lt;Server port&#x3D;&quot;8006&quot; shutdown&#x3D;&quot;SHUTDOWN&quot;&gt;		&#x2F;&#x2F;修改接收shutdown指令的端口</span><br><span class="line">&lt;Connector port&#x3D;&quot;8081&quot; protocol&#x3D;&quot;HTTP&#x2F;1.1&quot;		&#x2F;&#x2F;修改接收客户端请求的端口</span><br><span class="line">&lt;Connector port&#x3D;&quot;8010&quot; protocol&#x3D;&quot;AJP&#x2F;1.3&quot; redirectPort&#x3D;&quot;8443&quot; &#x2F;&gt;		&#x2F;&#x2F;修改接收其他web服务发送请求的端口</span><br><span class="line">sh &#x2F;usr&#x2F;local&#x2F;tomcat2&#x2F;bin&#x2F;startup.sh		&#x2F;&#x2F;启动第二个实例</span><br><span class="line">netstat -anpt | grep java		&#x2F;&#x2F;可以看到实例二所监听的端口8081、8006、8010</span><br></pre></td></tr></table></figure>
<h6 id="验证："><a href="#验证：" class="headerlink" title="验证："></a>验证：</h6><p>通过访问这两个tomcat节点，可以在这两个节点的站点目录下添加不同的文件来访问</p>
<p>添加示例一测试文件：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">mkdir &#x2F;usr&#x2F;local&#x2F;tomcat&#x2F;webapps&#x2F;1</span><br><span class="line">echo wo shi shi li yi &gt; &#x2F;usr&#x2F;local&#x2F;tomcat&#x2F;webapps&#x2F;1&#x2F;1.jsp</span><br></pre></td></tr></table></figure>
<p>添加示例二测试文件：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">mkdir &#x2F;usr&#x2F;local&#x2F;tomcat2&#x2F;webapps&#x2F;2</span><br><span class="line">echo wo shi shi li er &gt; &#x2F;usr&#x2F;local&#x2F;tomcat2&#x2F;webapps&#x2F;2&#x2F;2.jsp</span><br></pre></td></tr></table></figure>
<p>访问：</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># curl 1.1.1.1:8080&#x2F;1&#x2F;1.jsp</span><br><span class="line">wo shi shi li yi</span><br><span class="line"># curl 1.1.1.1:8081&#x2F;2&#x2F;2.jsp</span><br><span class="line">wo shi shi li er</span><br></pre></td></tr></table></figure>
<h5 id="Tomcat多虚拟主机"><a href="#Tomcat多虚拟主机" class="headerlink" title="Tomcat多虚拟主机"></a>Tomcat多虚拟主机</h5><p>在hosts文件中添加域名</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># vim /etc/hosts</span><br><span class="line"><span class="number">1.1</span><span class="number">.1</span><span class="number">.1</span> www.one.com</span><br><span class="line"><span class="number">1.1</span><span class="number">.1</span><span class="number">.1</span> www.two.com</span><br><span class="line"><span class="number">1.1</span><span class="number">.1</span><span class="number">.1</span> www.three.com</span><br></pre></td></tr></table></figure>
<p>再一个tomcat实例中添加多个Host模块，匹配多个站点目录供客户端访问</p>
<p>修改server.xml主配置文件</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/conf/server.xml</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-46.png" alt="upload successful"></p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line">&lt;Host name=&quot;www.one.com&quot; appBase=&quot;/one&quot;&gt;&lt;/Host&gt;		//客户端如果访问的url域名为www.one.com，则匹配的站点目录为/one</span><br><span class="line">        &lt;Host name=<span class="string">&quot;www.two.com&quot;</span> appBase=<span class="string">&quot;/two&quot;</span>&gt;		<span class="comment">//客户端如果访问的url域名为www.two.com，则匹配的站点目录为/two</span></span><br><span class="line">        &lt;/Host&gt;</span><br></pre></td></tr></table></figure>
<p>重启服务</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br></pre></td></tr></table></figure>
<p>创建站点目录/one和/two，并添加web应用</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># mkdir -p /one/o</span><br><span class="line"># echo one &gt; /one/o/aa.jsp</span><br><span class="line"># mkdir -p /two/t</span><br><span class="line"># echo two &gt; /two/t/bb.jsp</span><br></pre></td></tr></table></figure>
<p>在默认的webapps站点目录下创建目录cc，并添加web应用</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># mkdir /usr/local/tomcat/webapps/three</span><br><span class="line"># echo nin ben ci fang wen de ye mian lai zi zhan dian mu lu wei webapps xia &gt; /usr/local/tomcat/webapps/three/cc.jsp</span><br></pre></td></tr></table></figure>
<p>验证：</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># curl www.one.com:8080/o/aa.jsp</span><br><span class="line">one</span><br><span class="line"># curl www.two.com:8080/t/bb.jsp</span><br><span class="line">two</span><br></pre></td></tr></table></figure>
<p>访问<a target="_blank" rel="noopener" href="http://www.three.com:8080/three/cc.jsp%60%EF%BC%88%E6%9C%AC%E6%AC%A1%E8%AE%BF%E9%97%AE%E7%9A%84url%E5%9C%A8%E9%85%8D%E7%BD%AE%E6%96%87%E4%BB%B6%E4%B8%AD%E6%B2%A1%E6%9C%89%E6%8C%87%E5%AE%9A%E5%9F%9F%E5%90%8D%E6%89%80%E5%AF%B9%E5%BA%94%E7%9A%84%E7%AB%99%E7%82%B9%E7%9B%AE%E5%BD%95%EF%BC%8C%E6%89%80%E4%BB%A5%E8%AE%BF%E9%97%AE%E8%AF%A5%E5%9F%9F%E5%90%8D%E7%9A%84%E5%86%85%E5%AE%B9%E6%9D%A5%E8%87%AAtomcat%E9%BB%98%E8%AE%A4%E7%9A%84%E7%AB%99%E7%82%B9%E7%9B%AE%E5%BD%95webapps%E4%B8%8B%E7%9A%84three%E7%9A%84web%E5%BA%94%E7%94%A8%EF%BC%89%60">www.three.com:8080/three/cc.jsp`（本次访问的url在配置文件中没有指定域名所对应的站点目录，所以访问该域名的内容来自tomcat默认的站点目录webapps下的three的web应用）`</a></p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># curl www.three.com:8080/three/cc.jsp</span><br><span class="line">nin ben ci fang wen de ye mian lai zi zhan dian mu lu wei webapps xia</span><br></pre></td></tr></table></figure>
<h5 id="自定义web应用的访问位置"><a href="#自定义web应用的访问位置" class="headerlink" title="自定义web应用的访问位置"></a>自定义web应用的访问位置</h5><p>修改配置文件</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/conf/server.xml</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-47.png" alt="upload successful"></p>
<blockquote>
<p>如果客户端访问的url中域名为<a target="_blank" rel="noopener" href="http://www.two.com则匹配到的站点目录为/two">www.two.com则匹配到的站点目录为/two</a><br>如果客户端访问的url中域名为<a target="_blank" rel="noopener" href="http://www.two.com:8080/myself%EF%BC%8C%E5%88%99%E5%8C%B9%E9%85%8D%E7%9A%84%E7%AB%99%E7%82%B9%E7%9B%AE%E5%BD%95%E4%B8%BA/self">www.two.com:8080/myself，则匹配的站点目录为/self</a></p>
</blockquote>
<p>重启服务</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br><span class="line"></span><br></pre></td></tr></table></figure>
<p>创建/self站点目录</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># mkdir /self</span><br><span class="line"># echo this is myself &gt; /self/self.jsp</span><br></pre></td></tr></table></figure>
<p>访问</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># curl www.two.com:8080/t/bb.jsp</span><br><span class="line">two</span><br><span class="line"># curl www.two.com:8080/myself/self.jsp</span><br><span class="line">myself</span><br></pre></td></tr></table></figure>
<h5 id="编写内存测试页面"><a href="#编写内存测试页面" class="headerlink" title="编写内存测试页面"></a>编写内存测试页面</h5><figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br></pre></td><td class="code"><pre><span class="line">mkdir /one/memtest</span><br><span class="line">vim /one/memtest/meminfo.jsp</span><br><span class="line">&lt;%</span><br><span class="line">Runtime rtm = Runtime.getRuntime();		# 获取运行时间</span><br><span class="line">long mm = rtm.maxMemory()/1024/1024;	# 给JVM分配的最大内存</span><br><span class="line">long tm = rtm.totalMemory()/1024/1024;	# Java程序用掉的JVM内存</span><br><span class="line">long fm = rtm.freeMemory()/1024/1024;	# 给JVM分配完后剩余的内存</span><br><span class="line"></span><br><span class="line">out.println(<span class="string">&quot;memory info:&lt;br&gt;&quot;</span>);</span><br><span class="line">out.println(<span class="string">&quot;jvm max memory:&quot;</span>+mm+<span class="string">&quot;MB&quot;</span>+<span class="string">&quot;&lt;br&gt;&quot;</span>);</span><br><span class="line">out.println(<span class="string">&quot;jvm used:&quot;</span>+tm+<span class="string">&quot;MB&quot;</span>+<span class="string">&quot;&lt;br&gt;&quot;</span>);</span><br><span class="line">out.println(<span class="string">&quot;system free:&quot;</span>+fm+<span class="string">&quot;MB&quot;</span>+<span class="string">&quot;&lt;br&gt;&quot;</span>);</span><br><span class="line">out.println(<span class="string">&quot;can be used:&quot;</span>+(mm+fm-tm)+<span class="string">&quot;MB&quot;</span>+<span class="string">&quot;&lt;br&gt;&quot;</span>);</span><br><span class="line">%&gt;</span><br></pre></td></tr></table></figure>
<p>访问测试：</p>
<p><img src="/images/pasted-48.png" alt="upload successful"></p>
<h5 id="远程监控tomcat性能"><a href="#远程监控tomcat性能" class="headerlink" title="远程监控tomcat性能"></a>远程监控tomcat性能</h5><p>编写脚本</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/bin/catalina.sh</span><br><span class="line">添加：（<span class="number">309</span>行）</span><br><span class="line">JAVA_OPTS=&quot;$JAVA_OPTS -Djava.rmi.server.hostname=1.1.1.1&quot;	# 指定被连接的主机的IP/主机名/域名</span><br><span class="line">JAVA_OPTS=&quot;$JAVA_OPTS -Dcom.sun.management.jmxremote.port=9000&quot;	# 指定被连接的主机的端口</span><br><span class="line">JAVA_OPTS=&quot;$JAVA_OPTS -Dcom.sun.management.jmxremote.authenticate=true&quot;	# 指定连接时使用的身份验证</span><br><span class="line">JAVA_OPTS=&quot;$JAVA_OPTS -Dcom.sun.management.jmxremote.ssl=false&quot;	# 指定连接时使用的身份验证</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-49.png" alt="upload successful"></p>
<p>设置用于远程连接的用户和密码</p>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"># cp &#x2F;usr&#x2F;local&#x2F;java&#x2F;jre&#x2F;lib&#x2F;management&#x2F;jmxremote.password.template &#x2F;usr&#x2F;local&#x2F;java&#x2F;jre&#x2F;lib&#x2F;management&#x2F;jmxremote.password</span><br><span class="line"># vim  &#x2F;usr&#x2F;local&#x2F;java&#x2F;jre&#x2F;lib&#x2F;management&#x2F;jmxremote.password</span><br><span class="line">取消注释：</span><br><span class="line"> 用户名		  密码</span><br><span class="line">monitorRole		123456</span><br><span class="line">controlRole		123456</span><br></pre></td></tr></table></figure>
<p>对password文件提权</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># chmod 600 /usr/local/java/jre/lib/management/jmxremote.password</span><br></pre></td></tr></table></figure>
<p>重启服务：</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; /usr/local/tomcat/bin/startup.sh</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-50.png" alt="upload successful"></p>
<p>放行防火墙（不行就关闭防火墙）</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line"># firewall-cmd --add-port=8080/tcp</span><br><span class="line"># firewall-cmd --add-port=8005/tcp</span><br><span class="line"># firewall-cmd --add-port=8009/tcp</span><br><span class="line"># firewall-cmd --add-port=9000/tcp</span><br><span class="line"># setenforce 0</span><br></pre></td></tr></table></figure>
<p>打开一台虚拟机（只需要部署JDK）</p>
<p>远程连接</p>
<p>jconsole</p>
<p><img src="/images/pasted-51.png" alt="upload successful"></p>
<p><img src="/images/pasted-52.png" alt="upload successful"></p>
<p><img src="/images/pasted-53.png" alt="upload successful"></p>
<h5 id="自定义错误页面"><a href="#自定义错误页面" class="headerlink" title="自定义错误页面"></a>自定义错误页面</h5><p>初次访问一个不存在的错误页面结果</p>
<p><img src="/images/pasted-54.png" alt="upload successful"><br>修改web页面配置文件</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/conf/web.xml</span><br><span class="line">添加：（<span class="number">117</span>行）</span><br><span class="line">&lt;error-page&gt;</span><br><span class="line">        &lt;error-code&gt;404&lt;/error-code&gt;</span><br><span class="line">        &lt;location&gt;/notfound.jsp&lt;/location&gt;	# 指定错误页面的文件</span><br><span class="line">&lt;/error-page&gt;</span><br></pre></td></tr></table></figure>
<p>编写要返回给客户端的错误页面</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/webapps/ROOT/notfound.jsp</span><br><span class="line">Not Found！</span><br></pre></td></tr></table></figure>
<p>重启服务</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br></pre></td><td class="code"><pre><span class="line"># cd /usr/local/tomcat/bin/</span><br><span class="line"># ./shutdown.sh</span><br><span class="line"># ./startup.sh</span><br></pre></td></tr></table></figure>
<p>如提示报错：（显示地址被占用）</p>
<p><img src="/images/pasted-55.png" alt="upload successful"></p>
<p><img src="/images/pasted-56.png" alt="upload successful"></p>
<p>直接杀死相关的进程号就OK！</p>
<p>kill -9 50831</p>
<p>再次关闭、启动就OK！</p>
<p>测试访问：（访问一个不存在的页面）</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># curl 127.0.0.1:8080/zx.jsp</span><br><span class="line">Not Found!</span><br></pre></td></tr></table></figure>
<h5 id="通过web页面来管理虚拟主机"><a href="#通过web页面来管理虚拟主机" class="headerlink" title="通过web页面来管理虚拟主机"></a>通过web页面来管理虚拟主机</h5><p>将打包好的web应用bdqnweb.war拷贝到宿主目录下</p>
<p><img src="/images/pasted-57.png" alt="upload successful"></p>
<p>修改配置文件</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">取消注释并设置可访问管理界面的用户（最后）</span><br><span class="line"># vim /usr/local/tomcat/conf/tomcat-users.xml</span><br><span class="line">&lt;role rolename=&quot;admin-gui&quot;/&gt;	# 设置可以访问host-manager这个web应用的html的权限</span><br><span class="line">&lt;role rolename=&quot;admin-script&quot;/&gt;	# 设置可以访问txt类型页面的权限</span><br><span class="line">&lt;user username=&quot;aa&quot; password=&quot;123.com&quot; roles=&quot;admin-gui,admin-script&quot;/&gt;	# 添加用户aa密码为123.com，拥有admin-gui和admin-script两个权限</span><br></pre></td></tr></table></figure>
<p>重启服务</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br></pre></td></tr></table></figure>
<p>验证</p>
<blockquote>
<p>访问管理虚拟主机页面并添加虚拟主机</p>
</blockquote>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">firefox <span class="number">127.0</span><span class="number">.0</span><span class="number">.1</span>:<span class="number">8080</span>/host-manager</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-59.png" alt="upload successful"></p>
<p><img src="/images/pasted-60.png" alt="upload successful"></p>
<p><img src="/images/pasted-61.png" alt="upload successful"><br>创建<a target="_blank" rel="noopener" href="http://www.test.com域名所对应的站点目录,并添加web应用/">www.test.com域名所对应的站点目录，并添加web应用</a></p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># mkdir -p /test/app1</span><br><span class="line"># echo www.test.com &gt; /test/app1/test.jsp</span><br></pre></td></tr></table></figure>
<p>修改hosts文件添加域名</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># echo &quot;1.1.1.1 www.test.com&quot; &gt;&gt; /etc/hosts</span><br></pre></td></tr></table></figure>
<p>验证：</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># curl www.test.com:8080/app1/test.jsp</span><br><span class="line">www.test.com</span><br></pre></td></tr></table></figure>
<p>设置允许其他地址访问<code>Host-manager管理界面</code>（<code>默认地址为127.0.0.1可访问</code>）</p>
<blockquote>
<p><u>如果使用本机的物理IP访问<strong>host-manager</strong>管理界面是不可以访问的因为在配置文件中没有指定其他IP访问管理界面，所以在配置文件中可以指定其他IP允许访问管理界面</u></p>
</blockquote>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">vim /usr/local/tomcat/webapps/host-manager/META-INF/context.xml</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-62.png" alt="upload successful"></p>
<blockquote>
<p>在正则表达式里面“点”为任意所有的意思，所以在这里需要用“\”这个符号进行转义（<code>^.*$代表允许所有地址可访问</code>）</p>
</blockquote>
<p>重启服务</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br><span class="line"></span><br></pre></td></tr></table></figure>
<p>验证</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">firefox <span class="number">1.1</span><span class="number">.1</span><span class="number">.1</span>:<span class="number">8080</span>/host-manager</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-63.png" alt="upload successful"></p>
<p><img src="/images/pasted-64.png" alt="upload successful"><br>访问成功！！！</p>
<blockquote>
<p><u>重启服务后在管理界面添加的虚拟主机域名会消失，因为重启后服务会读取配置文件中的数据，在管理界面添加的虚拟主机不记录在配置文件中，所以会消失，但是消失的虚拟主机所对应的数据还在，只是虚拟主机的域名不存在。</u></p>
</blockquote>
<blockquote>
<p>访问manager控制界面（如果虚拟主机和发布web应用一起做的话一起修改tomcat-users配置文件，如果先做虚拟主机在做发布web应用中间在重启服务，虚拟主机就会消失，建议一起修改配置文件）</p>
</blockquote>
<p>在配置文件中3yy，p复制粘贴这三行并修改</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">vim /usr/local/tomcat/conf/tomcat-users.xml</span><br><span class="line">&lt;role rolename=&quot;manager-gui&quot;/&gt;	# 设置可以访问manager这个web应用的html权限</span><br><span class="line">&lt;role rolename=&quot;manager-script&quot;/&gt;	# 设置可以访问txt类型页面的权限</span><br><span class="line">&lt;user username=&quot;bb&quot; password=&quot;123.com&quot; roles=&quot;manager-gui,manager-script&quot;/&gt;	# 添加可以访问的用户bb，密码为123.聪明，拥有manager-gui和manager-script两个权限 </span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-65.png" alt="upload successful"><br>重启服务</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br></pre></td></tr></table></figure>
<p>访问</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">firefox <span class="number">127.0</span><span class="number">.0</span><span class="number">.1</span>:<span class="number">8080</span>/manager</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-66.png" alt="upload successful"></p>
<h6 id="第一种发布web应用方式"><a href="#第一种发布web应用方式" class="headerlink" title="第一种发布web应用方式"></a>第一种发布web应用方式</h6><p><img src="/images/pasted-67.png" alt="upload successful"></p>
<p><img src="/images/pasted-68.png" alt="upload successful"></p>
<p><img src="/images/pasted-69.png" alt="upload successful"><br><strong>发布成功后顶部显示OK</strong></p>
<p><img src="/images/pasted-70.png" alt="upload successful"></p>
<p>当然在tomcat的默认站点目录webapps下会生成一个bdqnweb应用</p>
<p><img src="/images/pasted-71.png" alt="upload successful"></p>
<p>访问bdqnweb应用</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">firefox <span class="number">127.0</span><span class="number">.0</span><span class="number">.1</span>:<span class="number">8080</span>/bdqnweb/</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-72.png" alt="upload successful">)</p>
<h6 id="第二种发布方式"><a href="#第二种发布方式" class="headerlink" title="第二种发布方式"></a>第二种发布方式</h6><p><img src="/images/pasted-73.png" alt="upload successful"><br><strong>发布成功后顶部显示OK</strong></p>
<p><img src="/images/pasted-74.png" alt="upload successful"><br>/hello不需要在webapps目录下提前创建，发布成功后会自动生成</p>
<p><img src="/images/pasted-75.png" alt="upload successful"><br>访问</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># curl 127.0.0.1:8080/hello</span><br><span class="line">Hello World!</span><br></pre></td></tr></table></figure>
<p>设置允许其他地址访问<strong>manager</strong>管理界面（<code>默认地址为127.0.0.1可访问</code>）<br>修改配置文件</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">vim /usr/local/tomcat/webapps/manager/META-INF/context.xml</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-76.png" alt="upload successful"></p>
<p>*<em>（^.</em>$代表允许所有地址可访问）**</p>
<p>重启服务</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br></pre></td></tr></table></figure>
<p>验证访问</p>
<p><img src="/images/pasted-77.png" alt="upload successful"></p>
<p><img src="/images/pasted-78.png" alt="upload successful"></p>
<h5 id="JVM常用内存优化参数"><a href="#JVM常用内存优化参数" class="headerlink" title="JVM常用内存优化参数"></a>JVM常用内存优化参数</h5><figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/bin/catalina.sh</span><br><span class="line">添加：</span><br><span class="line">JAVA_OPTS=<span class="string">&quot;-server -Xms512M -Xmx512M -XX:NewSize=300M -XX:OldSize=100M -XX:SurvivorRatio=2&quot;</span></span><br><span class="line">-Xms512：指定JVM初始化分配的内存</span><br><span class="line">-Xmx512：指定JVM最大获取到的内存</span><br><span class="line">-XX:NewSize=300M：指定新生代的内存容量</span><br><span class="line">-XX:OldSize=100M：指定年老代的内存容量</span><br><span class="line">-XX:SurvivorRatio=<span class="number">2</span>：指定Survivor与Eden的占比</span><br><span class="line">#-XX:PermSize：指定持久代的容量</span><br><span class="line">#-XX:PermMaxSize：指定持久代的最大容量</span><br><span class="line">#-XX:NewMaxSize：指定新生代的最大内存容量</span><br></pre></td></tr></table></figure>
<p>指定线程池</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br></pre></td><td class="code"><pre><span class="line"># vim /usr/local/tomcat/conf/server.xml</span><br><span class="line">修改：去掉注释（<span class="number">56</span>行）</span><br><span class="line">指定线程池，名字为threadpool，最大可开启线程数量为<span class="number">150</span>个，最下空闲进程数量<span class="number">4</span>个</span><br><span class="line">    &lt;Executor name=<span class="string">&quot;threadPool&quot;</span> namePrefix=<span class="string">&quot;catalina-exec-&quot;</span></span><br><span class="line">        maxThreads=<span class="string">&quot;150&quot;</span> minSpareThreads=<span class="string">&quot;4&quot;</span>/&gt;</span><br><span class="line">连接器引用指定名字对应的线程池</span><br><span class="line">    &lt;Connector port=<span class="string">&quot;8080&quot;</span> protocol=<span class="string">&quot;HTTP/1.1&quot;</span></span><br><span class="line">        executor=<span class="string">&quot;threadPool&quot;</span></span><br><span class="line">               connectionTimeout=<span class="string">&quot;20000&quot;</span></span><br><span class="line">               redirectPort=<span class="string">&quot;8443&quot;</span> /&gt;</span><br></pre></td></tr></table></figure>
<p>重启服务</p>
<figure class="highlight java"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># sh /usr/local/tomcat/bin/shutdown.sh &amp;&amp; sh /usr/local/tomcat/bin/startup.sh</span><br><span class="line"></span><br></pre></td></tr></table></figure>
<p>验证访问</p>
<figure class="highlight"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line"># firefox www.new.com:8080/manager</span><br></pre></td></tr></table></figure>
<p><img src="/images/pasted-79.png" alt="upload successful"></p>
<p><img src="/images/pasted-80.png" alt="upload successful"></p>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/01/21/Tomcat/">http://example.com/2021/01/21/Tomcat/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/01/21/Linux%E6%9D%83%E9%99%90%E7%AE%A1%E7%90%86%E4%B9%8BACL%E6%9D%83%E9%99%90/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Linux权限管理之ACL权限</div></div></a></div><div class="next-post pull-right"><a href="/2021/01/21/Ansible%E5%B8%B8%E7%94%A8%E6%A8%A1%E5%9D%97/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Ansible常用模块</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-5"><a class="toc-link" href="#Tomcat-%E6%98%AF%E4%BB%80%E4%B9%88"><span class="toc-number">1.</span> <span class="toc-text">Tomcat 是什么?</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2tomcat"><span class="toc-number">2.</span> <span class="toc-text">部署tomcat</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#Tomcat%E5%A4%9A%E5%AE%9E%E4%BE%8B"><span class="toc-number">3.</span> <span class="toc-text">Tomcat多实例</span></a><ol class="toc-child"><li class="toc-item toc-level-6"><a class="toc-link" href="#%E9%AA%8C%E8%AF%81%EF%BC%9A"><span class="toc-number">3.1.</span> <span class="toc-text">验证：</span></a></li></ol></li><li class="toc-item toc-level-5"><a class="toc-link" href="#Tomcat%E5%A4%9A%E8%99%9A%E6%8B%9F%E4%B8%BB%E6%9C%BA"><span class="toc-number">4.</span> <span class="toc-text">Tomcat多虚拟主机</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#%E8%87%AA%E5%AE%9A%E4%B9%89web%E5%BA%94%E7%94%A8%E7%9A%84%E8%AE%BF%E9%97%AE%E4%BD%8D%E7%BD%AE"><span class="toc-number">5.</span> <span class="toc-text">自定义web应用的访问位置</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#%E7%BC%96%E5%86%99%E5%86%85%E5%AD%98%E6%B5%8B%E8%AF%95%E9%A1%B5%E9%9D%A2"><span class="toc-number">6.</span> <span class="toc-text">编写内存测试页面</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#%E8%BF%9C%E7%A8%8B%E7%9B%91%E6%8E%A7tomcat%E6%80%A7%E8%83%BD"><span class="toc-number">7.</span> <span class="toc-text">远程监控tomcat性能</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#%E8%87%AA%E5%AE%9A%E4%B9%89%E9%94%99%E8%AF%AF%E9%A1%B5%E9%9D%A2"><span class="toc-number">8.</span> <span class="toc-text">自定义错误页面</span></a></li><li class="toc-item toc-level-5"><a class="toc-link" href="#%E9%80%9A%E8%BF%87web%E9%A1%B5%E9%9D%A2%E6%9D%A5%E7%AE%A1%E7%90%86%E8%99%9A%E6%8B%9F%E4%B8%BB%E6%9C%BA"><span class="toc-number">9.</span> <span class="toc-text">通过web页面来管理虚拟主机</span></a><ol class="toc-child"><li class="toc-item toc-level-6"><a class="toc-link" href="#%E7%AC%AC%E4%B8%80%E7%A7%8D%E5%8F%91%E5%B8%83web%E5%BA%94%E7%94%A8%E6%96%B9%E5%BC%8F"><span class="toc-number">9.1.</span> <span class="toc-text">第一种发布web应用方式</span></a></li><li class="toc-item toc-level-6"><a class="toc-link" href="#%E7%AC%AC%E4%BA%8C%E7%A7%8D%E5%8F%91%E5%B8%83%E6%96%B9%E5%BC%8F"><span class="toc-number">9.2.</span> <span class="toc-text">第二种发布方式</span></a></li></ol></li><li class="toc-item toc-level-5"><a class="toc-link" href="#JVM%E5%B8%B8%E7%94%A8%E5%86%85%E5%AD%98%E4%BC%98%E5%8C%96%E5%8F%82%E6%95%B0"><span class="toc-number">10.</span> <span class="toc-text">JVM常用内存优化参数</span></a></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>